:: Build Script Helper for vs2005
:: (C) 2007 Gianluigi Tiesi <sherpya@netfarm.it>
:: License: Public Domain (i.e. use as like you want)

@echo off
setlocal
set WDK_ROOT=J:\WinDDK\6000
set TOBUILD=sys cpl cli svc

if "%1"=="checked" goto action
if "%1"=="free" goto action
if "%1"=="cleanall" goto cleanall
if "%1"=="distclean" goto distclean
if "%1"=="clean" goto clean
goto usage

:action
if not exist %WDK_ROOT% goto nowdk
pushd .
call %WDK_ROOT%\bin\setenv %WDK_ROOT% wnet %1 %2
popd

if "%DDKBUILDENV%"=="" goto nowdk
if "%3"=="clean" goto clean

echo Building %1 %2 %3...
build %3
goto exit

:clean
echo Cleaning %1 %2 %3...
rmdir /s/q obj%BUILD_ALT_DIR% 2>NUL:
del /f/q build%BUILD_ALT_DIR%.* 2>NUL:
del /f/q checked free 2>NUL:
del /f/q x64 2>NUL:
goto exit

:cleanall
echo Cleaning binaries
for /d %%i in (bin\*) do rmdir /s/q %%i
del /f/q *.log *.err *.wrn 2>NUL:
for %%i in (%TOBUILD%) do if exist %%i\sources for %%j in (checked free) do for %%k in (i386 amd64 ia64) do (cd %%i && call ..\wdkbuild %%j %%k clean && cd ..)
goto exit

:distclean
call wdkbuild cleanall
attrib -h *.suo 2>NUL:
del /f/q *.ncb *.suo 2>NUL:
for %%i in (%TOBUILD%) do del %%i\*.vcproj.*.user 2>NUL:
goto exit

:usage
echo syntax: wdkbuild cleanall|distclean|checked|free arch [-c|clean]
goto exit

:nowdk
echo Can't find the WDK, check the path in wdkbuild.bat
goto exit

:exit
endlocal
